unit mainwnd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Videocap,videodisp,vfw, StdCtrls, ExtCtrls, Buttons,syncobjs;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    BtStart: TButton;
    BtStop: TButton;
    Btformat: TButton;
    BtDriver: TButton;
    Panel3: TPanel;
    Label13: TLabel;
    Label1: TLabel;
    EdFrame: TEdit;
    BTCompress: TBitBtn;
    VideoCap1: TVideoCap;
    EdFile: TEdit;
    Label2: TLabel;
    VideoDisp1: TVideoDisp;
    procedure FormCreate(Sender: TObject);
    procedure Video1VideoStream(sender: TObject; lpVhdr: PVIDEOHDR);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtFormatClick(Sender: TObject);
    procedure BtStartClick(Sender: TObject);
    procedure BtStopClick(Sender: TObject);
    procedure BtDriverClick(Sender: TObject);
    procedure Video1DblClick(Sender: TObject);
    procedure BTCompressClick(Sender: TObject);
  private
   count:integer; // Frame Counter
  

    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  MainForm: TMainForm;

implementation

uses DlgTreiber;

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
   VideoCap1.Videopreview:= true;
end;



procedure TMainForm.Video1VideoStream(sender: TObject; lpVhdr: PVIDEOHDR);
var Bitmap:TBitmap;
    info:TBitmapInfo;
    text:string;
 //   delay:TSimpleEvent;

begin
 inc(count);  // frame Counter


// Creating a TBitmap  Frame -> Bitmap-> Drawing to Bitmap -> Bitmap to Frame
info:= videocap1.BitMapInfo;
Bitmap:=TBitmap.Create;
bitmap.Pixelformat:= pf32bit;
frameToBitmap(Bitmap,lpvhdr^.lpData,Info);
with bitmap do
begin
 canvas.font.Color:= clred;
 SetBkMode(canvas.handle,windows.transparent);
 text:= DateTimeToStr(now);
 canvas.Textout(0, info.bmiHeader.biHeight - canvas.textheight(text), text);
end;
BitmapToFrame(bitmap,lpvhdr^.lpdata,Info);
Bitmap.free;

// Frame to Display
VideoDisp1.DrawStream(lpVhdr^.lpData, lpVHdr^.dwFlags and VHDR_KEYFRAME = VHDR_KEYFRAME);

 // Frame Counter
EdFrame.Text:= inttostr(count);

// Delay 1 sec
//delay:= TSimpleEvent.Create;
//delay.Waitfor(1000);
//delay.free;




end;




procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  VideoCap1.StopCapture;
end;

procedure TMainForm.BtFormatClick(Sender: TObject);
begin
 VideoCap1.DlgVFormat;
end;

procedure TMainForm.BtStartClick(Sender: TObject);
var Vheader:TBitmapInfoHeader;

begin

 // This Programm will only work with RGB-Coded Data becourse BitmapToFrame and FrameToBitmap
Vheader:=Videocap1.BitMapInfoHeader;
VHeader.bicompression:=bi_RGB;   // Always RGB-Data
VHeader.biBitCount:= 24;
VideoCap1.BitMapInfoHeader:= VHeader;

Videocap1.VideoFileName:=EdFile.text;
VideoDisp1.Streaming:= true;
VideoDisp1.BitMapInfoHeader:= Videocap1.BitMapInfoHeader;
VideoCap1.StartCapture;
BtStart.Enabled:= false;
btStop.Enabled:= true;
btFormat.Enabled:= false;
btDriver.Enabled:= false;

count:=0;

end;

procedure TMainForm.BtStopClick(Sender: TObject);
begin
 VideoCap1.StopCapture;
 VideoDisp1.Streaming:= false;
 BtStart.Enabled:= true;
 btStop.Enabled:= false;
 btFormat.Enabled:= true;
 btDriver.Enabled:= true;
end;

procedure TMainForm.BtDriverClick(Sender: TObject);

Var DrvList:TStrings;
begin
 DlgEinstell:=TDlgEinstell.Create(Self);
 drvList:=  GetDriverList;
 dlgEinstell.Combobox1.Items:= drvList;
 VideoCap1.DriverOpen:= false;
 dlgEinstell.ComboBox1.Itemindex:= VideoCap1.DriverIndex;
 if DlgEinstell.ShowModal = mrOK then
    begin
      videoCap1.DriverIndex:= dlgEinstell.combobox1.ItemIndex;
    end;
 VideoCap1.DriverOpen:= true;
 VideoCap1.Videopreview:= true;
 DlgEinstell.Free;
 drvList.Clear;
 drvList.Free;
end;

 

procedure TMainForm.Video1DblClick(Sender: TObject);
begin
   if BtStart.Enabled Then BtStartClick(Sender) else BtStopClick(Sender);
end;

procedure TMainForm.BTCompressClick(Sender: TObject);
begin
  VideoCap1.DlgVCompression;
end;

end.
